
/*******************************************************************

   	Macro:       cleanup;
   	Author:      Harry Droogendyk        harry@stratia.ca
   	Date:        2008/07/12

   	Clean up global macro variables and/or WORK datasets

/*******************************************************************/

%macro cleanup(help,data=Y,macro=Y);

	%if &help = ? or %upcase(&help) = HELP %then %do;
		%put;
		%put %nrstr(%cleanup(data=Y,macro=Y););
		%put %nrstr(Cleans up WORK datasets and global macro variables.);
		%put %nrstr(Parms: &data  - Y=delete work datasets, default=Y);
		%put %nrstr(       &macro - Y=delete global macro variables, default=Y);
		%put %nrstr(Use:   %cleanup(macro=N););

	%end; %else %do;

		%if &data  = %str() %then %let data  = Y; %else %let data  = %upcase(&data);
		%if &macro = %str() %then %let macro = Y; %else %let macro = %upcase(&macro);

		%if &data = Y %then %do;
			%put NOTE: %nrstr(%cleanup is deleting WORK datasets);
			proc datasets lib=work nolist nowarn nodetails
				kill;
			quit;
		%end;

		%if &macro = Y %then %do;
			%put NOTE: %nrstr(%cleanup is deleting GLOBAL macro variables);
			data _null_;
				length cmd $200;
				set sashelp.vmacro;
					where scope = 'GLOBAL' and offset = 0 and name ne: 'SYSDB';
				cmd = '%nrstr(%symdel ' || trim(name) || ' / nowarn );';
				call execute(cmd);
			run;
		%end;

  %end;

%mend cleanup;

%cleanup(?);

%cleanup;
